# nmap – Uses nmap to find hosts to target

New in version 2.6.

- Synopsis
- Requirements
- Parameters
- Notes
- Examples
- Status

## Synopsis

- Uses a YAML configuration file with a valid YAML extension.

## Requirements

The below requirements are needed on the local master node that executes this inventory.

- nmap CLI installed

## Parameters

Parameter | Choices/Defaults | Configuration | Comments
--- | --- | --- | ---
address - / required |  |  | Network IP or range of IPs to scan, you can use a simple range (10.2.2.15-25) or CIDR notation.

cache
boolean

Choices:
- no ←
- yes

ini entries:

[inventory]
cache = no

env:ANSIBLE_INVENTORY_CACHE

Toggle to enable/disable the caching of the inventory's source data, requires a cache plugin setup to work.

cache_connection string |  | ini entries: [defaults] fact_caching_connection = VALUE [inventory] cache_connection = VALUE env:ANSIBLE_CACHE_PLUGIN_CONNECTION env:ANSIBLE_INVENTORY_CACHE_CONNECTION | Cache connection data or path, read cache plugin documentation for specifics.
cache_plugin string | Default: "memory" | ini entries: [defaults] fact_caching = memory [inventory] cache_plugin = memory env:ANSIBLE_CACHE_PLUGIN env:ANSIBLE_INVENTORY_CACHE_PLUGIN | Cache plugin to use for the inventory's source data.
cache_prefix - | Default: "ansible_inventory_" | ini entries: [default] fact_caching_prefix = ansible_inventory_ [inventory] cache_prefix = ansible_inventory_ env:ANSIBLE_CACHE_PLUGIN_PREFIX env:ANSIBLE_INVENTORY_CACHE_PLUGIN_PREFIX | Prefix to use for cache plugin files/tables
cache_timeout integer | Default: 3600 | ini entries: [defaults] fact_caching_timeout = 3600 [inventory] cache_timeout = 3600 env:ANSIBLE_CACHE_PLUGIN_TIMEOUT env:ANSIBLE_INVENTORY_CACHE_TIMEOUT | Cache duration in seconds
compose dictionary | Default: {} |  | Create vars from jinja2 expressions.
exclude list |  |  | list of addresses to exclude
groups dictionary | Default: {} |  | Add hosts to group based on Jinja2 conditionals.
ipv4 boolean | Default: "yes" |  | use IPv4 type addresses
ipv6 boolean | Default: "yes" |  | use IPv6 type addresses
keyed_groups list | Default: [] |  | Add hosts to group based on the values of a variable.

plugin
- / required

Choices:
- nmap

token that ensures this is a source file for the 'nmap' plugin.

ports boolean | Default: "yes" |  | Enable/disable scanning for open ports

strict
boolean

Choices:
- no ←
- yes

If `yes` make invalid entries a fatal error, otherwise skip and continue.
Since it is possible to use facts in the expressions they might not always be available and we ignore those errors by default.

## Notes

Note

- At least one of ipv4 or ipv6 is required to be True, both can be True, but they cannot both be False.
- TODO: add OS fingerprinting

## Examples

    # inventory.config file in YAML format
    plugin: nmap
    strict: False
    address: 192.168.0.0/24

## Status

- This inventory is not guaranteed to have a backwards compatible interface. [preview]
- This inventory is maintained by the Ansible Community. [community]

### Authors

- UNKNOWN

Hint

If you notice any issues in this documentation, you can edit this document to improve it.

Hint

Configuration entries for each entry type have a low to high priority order. For example, a variable that is lower in the list will override a variable that is higher up.